#!/usr/bin/env python3

import subprocess
import tempfile
import os
import re
from termcolor import colored, cprint

from processor3D import amf
from processor3D import slicer


class Slicer():
    def __init__(self):
        self.inifile = None
        self.slicer_binary = os.path.abspath(os.path.join(os.path.dirname(__file__), '../resources/Slic3r-1.3.1.AppImage'))
        # self.slicer_binary = "slic3r"
        self.slicer_binary = "~/Slic3r.AppImage"
        self.render_file = None
        self.gcode_file = None
        self.default_profile = None

    def set_amf(self, file):
        self.render_file = file
        self.gcode_file = file.replace('.amf', '.gcode')

    def set_default_profile(self, file, overwrite=True):
        if overwrite or not self.inifile:
            self.inifile = file

    def slice(self, gcode = None):
        if gcode:
            self.gcode_file = gcode
        options = [self.slicer_binary]
        options += ['--no-gui']
        options += ['-o', self.gcode_file]
        if self.inifile:
            options += ['--load', self.inifile]
        options += [self.render_file]

        call = ' '.join(options)
        cprint(call, 'yellow')
        subprocess.call(call, shell=True)
